#include "imageaes.h"
#include "aes.h"
#include "des.h"

void data_encrypt(unsigned char* outputbuf,
		const unsigned char* inputbuf,
		const unsigned char* key,int keylength) {
	const unsigned char* key2[3];
	int i;
	switch(password.crypttype) {
		case CRYPT_AES:
			switch(keylength) {
				case 16:
					aes_encript(outputbuf,inputbuf,key,AES_128);
					break;
				case 24:
					aes_encript(outputbuf,inputbuf,key,AES_192);
					break;
				case 32:
					aes_encript(outputbuf,inputbuf,key,AES_256);
					break;
			}
			break;
		case CRYPT_DES:
			key2[0]=&key[0];
			key2[1]=keylength>=16?&key[8]:&key[0];
			key2[2]=keylength>=24?&key[16]:&key[0];
			DesEncode(&outputbuf[0],&inputbuf[0],key2[0]);
			DesDecode(&outputbuf[0],&inputbuf[0],key2[1]);
			DesEncode(&outputbuf[0],&inputbuf[0],key2[2]);
			DesEncode(&outputbuf[8],&inputbuf[8],key2[0]);
			DesDecode(&outputbuf[8],&inputbuf[8],key2[1]);
			DesEncode(&outputbuf[8],&inputbuf[8],key2[2]);
			break;
		case CRYPT_XOR:
			for(i=0;i<16;i++) {
				outputbuf[i]=inputbuf[i] ^ key[i%keylength];
			}
			break;
		case CRYPT_CAESAR:
			for(i=0;i<16;i++) {
				outputbuf[i]=inputbuf[i] + key[i%keylength];
			}
			break;
	}
}

void data_decrypt(unsigned char* outputbuf,
		const unsigned char* inputbuf,
		const unsigned char* key,int keylength) {
	const unsigned char* key2[3];
	int i;
	switch(password.crypttype) {
		case CRYPT_AES:
			switch(keylength) {
				case 16:
					aes_decript(outputbuf,inputbuf,key,AES_128);
					break;
				case 24:
					aes_decript(outputbuf,inputbuf,key,AES_192);
					break;
				case 32:
					aes_decript(outputbuf,inputbuf,key,AES_256);
					break;
			}
			break;
		case CRYPT_DES:
			key2[0]=&key[0];
			key2[1]=keylength>=16?&key[8]:&key[0];
			key2[2]=keylength>=24?&key[16]:&key[0];
			DesDecode(&outputbuf[0],&inputbuf[0],key2[0]);
			DesEncode(&outputbuf[0],&inputbuf[0],key2[1]);
			DesDecode(&outputbuf[0],&inputbuf[0],key2[2]);
			DesDecode(&outputbuf[8],&inputbuf[8],key2[0]);
			DesEncode(&outputbuf[8],&inputbuf[8],key2[1]);
			DesDecode(&outputbuf[8],&inputbuf[8],key2[2]);
			break;
		case CRYPT_XOR:
			for(i=0;i<16;i++) {
				outputbuf[i]=inputbuf[i] ^ key[i%keylength];
			}
			break;
		case CRYPT_CAESAR:
			for(i=0;i<16;i++) {
				outputbuf[i]=inputbuf[i] - key[i%keylength];
			}
			break;
	}
}
