#include "imageaes.h"
#include <stdio.h>
#include <stdlib.h>
#include "png.h"

/*
http://gmoon.jp/png/
http://dencha.ojaru.jp/programs_07/pg_graphic_10a2.html
http://hi.baidu.com/xiaoyunhu/blog/item/ac5c1b553bfb7cc3b645ae3c.html
Ql
*/ 

bmp_t* loadPng(const char* filename) {
	bmp_t*          bmp;
	FILE            *fp;
	unsigned char   header[8];
	png_structp     png_ptr;
	png_infop       info_ptr;
	png_uint_32     width, height;
	int             bit_depth, color_type, interlace_type;
	unsigned char   **image;
	int             i,j;
	/*PNGǂݎ菈*/
	fp = fopen(filename, "rb");
	if(fp==NULL)return NULL;
	fread(header,1,8,fp);
	if(png_sig_cmp(header,0,8)) {
		fclose(fp);
		return NULL;
	}
	png_ptr = png_create_read_struct(
	                PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	if(!png_ptr) {
		fclose(fp);
		return NULL;
	}
	info_ptr = png_create_info_struct(png_ptr);
	if(!info_ptr) {
		png_destroy_read_struct(&png_ptr, (png_infopp)NULL, (png_infopp)NULL);
		fclose(fp);
		return NULL;
	}
	if (setjmp(png_jmpbuf(png_ptr))) {
		png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
		fclose(fp);
		return NULL;
	}
	png_init_io(png_ptr, fp);
	png_set_sig_bytes(png_ptr, 8);
	png_read_info(png_ptr, info_ptr);
	png_get_IHDR(png_ptr, info_ptr, &width, &height,
	                &bit_depth, &color_type, &interlace_type,
	                NULL, NULL);
	png_set_strip_alpha(png_ptr);
	if (color_type == PNG_COLOR_TYPE_PALETTE)
		png_set_palette_to_rgb(png_ptr);
	if (color_type == PNG_COLOR_TYPE_GRAY)
		png_set_gray_to_rgb(png_ptr);
	png_read_update_info(png_ptr, info_ptr);
	image = (png_bytepp)malloc(height * sizeof(png_bytep));
	for (i = 0; i < height; i++)
		image[i] = (png_bytep)malloc(png_get_rowbytes(png_ptr, info_ptr));
	png_read_image(png_ptr, image);
	png_read_end(png_ptr, NULL);
	/*摜̓ǂݎ*/
	bmp=bmpMake(width,height);
	if(bmp) {
		for(i=0;i<width;i++) {
			for(j=0;j<height;j++) {
				getBmpXY(bmp,i,j).r=image[j][i*3];
				getBmpXY(bmp,i,j).g=image[j][i*3+1];
				getBmpXY(bmp,i,j).b=image[j][i*3+2];
			}
		}
	}
	/*PNG̊J*/
	for (i = 0; i < height; i++) free(image[i]);
	free(image);
	png_destroy_read_struct(
	        &png_ptr, &info_ptr, (png_infopp)NULL);
	fclose(fp);
	/*摜Ԃ*/
	return bmp;
}

int savePng(const bmp_t* bmp,const char* filename) {
	FILE            *fp;
	png_structp     png_ptr;
	png_infop       info_ptr;
	png_uint_32     width, height;
	png_byte        **image;
	int             i,j;
	/*摜̏ݏ*/
	width=getBmpWidth(bmp);
	height=getBmpHeight(bmp);
	fp = fopen(filename, "wb");
	if(fp==NULL)return 0;
	png_ptr = png_create_write_struct(
		PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
	if (!png_ptr) {
		fclose(fp);
		return 0;
	}
	info_ptr = png_create_info_struct(png_ptr);
	if (!info_ptr) {
		png_destroy_write_struct(&png_ptr, (png_infopp)NULL);
		fclose(fp);
		return 0;
	}
	if (setjmp(png_jmpbuf(png_ptr))){
		png_destroy_write_struct(&png_ptr, &info_ptr);
		fclose(fp);
		return 0;
	}
	png_init_io(png_ptr, fp);
	png_set_IHDR(png_ptr, info_ptr, width, height,
		8, PNG_COLOR_TYPE_RGB, PNG_INTERLACE_NONE,
		PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);
	/*摜̏*/
	png_write_info(png_ptr, info_ptr);
	image = (png_bytepp)malloc(height * sizeof(png_bytep));
	for (i = 0; i < height; i++)
		image[i] = (png_bytep)malloc(png_get_rowbytes(png_ptr, info_ptr));
	for(i=0;i<height;i++) {
		for(j=0;j<width;j++) {
			image[i][j*3]=getBmpXY(bmp,j,i).r;
			image[i][j*3+1]=getBmpXY(bmp,j,i).g;
			image[i][j*3+2]=getBmpXY(bmp,j,i).b;
		}
	}
	png_write_image(png_ptr, image);
	/*㏈*/
	png_write_end(png_ptr, info_ptr);
	for (i = 0; i < height; i++) free(image[i]);
	free(image);
	png_destroy_write_struct(&png_ptr, &info_ptr);
	fclose(fp);
	return 1;
}
